package com.decoding.twodtg.demobarcodereader2dtg;

import android.Manifest;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.graphics.Point;
import android.net.Uri;
import android.os.Bundle;
import android.support.v4.app.ActivityCompat;
import android.support.v4.content.ContextCompat;
import android.view.Display;
import android.view.View;
import android.view.ViewGroup;
import android.view.ViewManager;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.TextView;

import java.util.Timer;
import java.util.TimerTask;

import decoding.twodtg.com.twodtgdecodelib2.BarcodeDecoderLibrary;

public class IntroActivity extends Activity
{
  private Timer timer;
  private MyTimerTask mMyTimerTask;
  private TextView txt;
  private TextView txt2;
  private BarcodeDecoderLibrary lib = new BarcodeDecoderLibrary();
  private boolean permissionsGranted = false;

  private boolean CheckPermissions()
  {
    if(android.os.Build.VERSION.SDK_INT < 23)
    {
      permissionsGranted = true;
    }else
    {
     permissionsGranted = true;
    }
    return permissionsGranted;
  }

  private void AskPermissions()
  {
    showExplanation(this,"2DTG notification.", "Our application is being initialized.\nOur license is tied to a specific device and its hardware parameters are used for this.\nWe do not use any user data!");
  }

  private void RequestPermissions()
  {
  }

  @Override
  public void onRequestPermissionsResult(int requestCode, String permissions[], int[] grantResults)
  {
    for(int i=0; i < grantResults.length; i++)
      if(grantResults[i] != 0)
        return;
    permissionsGranted = true;
    ShowLicens();
  }

  private void showExplanation(Activity act, String title, String message)
  {
    AlertDialog.Builder builder = new AlertDialog.Builder(this);
    builder.setTitle(title)
        .setMessage(message)
        .setPositiveButton(android.R.string.ok, new DialogInterface.OnClickListener() {
          public void onClick(DialogInterface dialog, int id)
          {
            RequestPermissions();
          }
        });
    builder.setOnCancelListener(new DialogInterface.OnCancelListener() {
      @Override
      public void onCancel(DialogInterface dialog) {
        RequestPermissions();
      }
    });
    builder.create().show();
  }

  private void ShowLicens()
  {
    boolean act = lib.isActivated(this);
    if(!act) // temporary. Work on sites
    {
      txt2.setText("Trial.");
    }else
    {
      txt2.setText("");
    }
  }

  @Override
  protected void onCreate(Bundle savedInstanceState)
  {
    super.onCreate(savedInstanceState);
    setContentView(R.layout.activity_intro);

    txt = (TextView) this.findViewById(R.id.textView);
    txt2 = (TextView) this.findViewById(R.id.textView2);

    if(!CheckPermissions())
    {
      // No access rights yet
      txt2.setText("Access rights necessary for work are not provided!");

      AskPermissions();
     }
    else
    {
      ShowLicens();
    }

    Display display = getWindowManager().getDefaultDisplay();
    Point size = new Point();
    display.getSize(size);
    if(size.y  < 700)
    {
      try
      {
        ImageView logo = (ImageView) this.findViewById(R.id.imageView);
        ((ViewManager) logo.getParent()).removeView(logo);
      }catch(Exception e)
      {}
    }

  }

  static public String SiteUrl = "http://2dtg.com/products/mobile-barcode-decoding/mobile-barcode-decoder-android";

  public void UrlClick(View v)
  {
    CloseTimer();
    if(!lib.isActivated(this))
    {

    }
    else
    {
      Intent browserIntent = new Intent(Intent.ACTION_VIEW, Uri.parse(SiteUrl));
      startActivity(browserIntent);
    }
  }

  public void Click(View v)
  {
    if(!permissionsGranted) return;
    MainActivity.Create(this);
  }

  @Override
  protected void onResume()
  {
    super.onResume();
    timer = new Timer();
    mMyTimerTask = new MyTimerTask();
    timer.schedule(mMyTimerTask, 5000);
  }

  @Override
  protected void onPause()
  {
    super.onPause();
    CloseTimer();
  }

  private void CloseTimer()
  {
    if (timer != null)
    {
      timer.cancel();
      timer.purge();
      timer = null;
    }
  }

  class MyTimerTask extends TimerTask
  {
    @Override
    public void run()
    {
      if(permissionsGranted)
        runOnUiThread(new Runnable()
      {
        @Override
        public void run()
        {
          Click(null);
        }
      });
    }
  }
}
